
class basic(object):
    def __init__(self, name):
        self._name  = name
        self._value = getattr(self, name, None)

    reset     = '\033[0m'
    bright    = '\033[1m'
    dim       = '\033[2m'
    normal    = '\033[22m'

    under     = '\033[4m'
    nounder   = '\033[24m'
    over      = '\033[53m'
    noover    = '\033[55m'

    bell      = '\a'
    endl      = '\033[0m\n'

    # use these for highest compatibility
    BLACK   = '\033[30m'
    RED     = '\033[31m'
    GREEN   = '\033[32m'
    YELLOW  = '\033[33m'
    BLUE    = '\033[34m'
    VIOLET  = '\033[35m'
    CYAN    = '\033[36m'
    WHITE   = '\033[37m'
    DEFAULT = '\033[39m'

    BG_BLACK   = '\033[40m'
    BG_RED     = '\033[41m'
    BG_GREEN   = '\033[42m'
    BG_YELLOW  = '\033[43m'
    BG_BLUE    = '\033[44m'
    BG_VIOLET  = '\033[45m'
    BG_CYAN    = '\033[46m'
    BG_WHITE   = '\033[47m'
    BG_DEFAULT = '\033[49m'


# xterm-256 colors
class xterm256(basic):
    aqua              = '\033[38;5;14m'
    aquamarine        = '\033[38;5;79m'
    aquamarine1       = '\033[38;5;86m'
    aquamarine2       = '\033[38;5;122m'
    black             = '\033[38;5;0m'
    blue              = '\033[38;5;12m'
    blue1             = '\033[38;5;21m'
    blue2             = '\033[38;5;19m'
    blue3             = '\033[38;5;20m'
    blueviolet        = '\033[38;5;57m'
    cadetblue         = '\033[38;5;72m'
    cadetblue1        = '\033[38;5;73m'
    chartreuse        = '\033[38;5;64m'
    chartreuse1       = '\033[38;5;70m'
    chartreuse2       = '\033[38;5;76m'
    chartreuse3       = '\033[38;5;82m'
    chartreuse4       = '\033[38;5;112m'
    chartreuse5       = '\033[38;5;118m'
    cornflowerblue    = '\033[38;5;69m'
    cornsilk          = '\033[38;5;230m'
    cyan              = '\033[38;5;51m'
    cyan2             = '\033[38;5;50m'
    cyan3             = '\033[38;5;43m'
    darkblue          = '\033[38;5;18m'
    darkcyan          = '\033[38;5;36m'
    darkgoldenrod     = '\033[38;5;136m'
    darkgreen         = '\033[38;5;22m'
    darkkhaki         = '\033[38;5;143m'
    darkmagenta       = '\033[38;5;90m'
    darkmagenta1      = '\033[38;5;91m'
    darkolivegreen    = '\033[38;5;107m'
    darkolivegreen1   = '\033[38;5;113m'
    darkolivegreen2   = '\033[38;5;149m'
    darkolivegreen3   = '\033[38;5;155m'
    darkolivegreen4   = '\033[38;5;191m'
    darkolivegreen5   = '\033[38;5;192m'
    darkorange        = '\033[38;5;130m'
    darkorange1       = '\033[38;5;166m'
    darkorange2       = '\033[38;5;208m'
    darkred           = '\033[38;5;52m'
    darkred1          = '\033[38;5;88m'
    darkseagreen      = '\033[38;5;65m'
    darkseagreen1     = '\033[38;5;71m'
    darkseagreen2     = '\033[38;5;108m'
    darkseagreen3     = '\033[38;5;115m'
    darkseagreen4     = '\033[38;5;150m'
    darkseagreen5     = '\033[38;5;151m'
    darkseagreen6     = '\033[38;5;157m'
    darkseagreen7     = '\033[38;5;158m'
    darkseagreen8     = '\033[38;5;193m'
    darkslategray     = '\033[38;5;87m'
    darkslategray1    = '\033[38;5;116m'
    darkslategray2    = '\033[38;5;123m'
    darkturquoise     = '\033[38;5;44m'
    darkviolet        = '\033[38;5;92m'
    darkviolet1       = '\033[38;5;128m'
    deeppink          = '\033[38;5;53m'
    deeppink1         = '\033[38;5;89m'
    deeppink2         = '\033[38;5;125m'
    deeppink3         = '\033[38;5;161m'
    deeppink4         = '\033[38;5;162m'
    deeppink5         = '\033[38;5;197m'
    deeppink6         = '\033[38;5;198m'
    deeppink7         = '\033[38;5;199m'
    deepskyblue       = '\033[38;5;23m'
    deepskyblue1      = '\033[38;5;24m'
    deepskyblue2      = '\033[38;5;25m'
    deepskyblue3      = '\033[38;5;31m'
    deepskyblue4      = '\033[38;5;32m'
    deepskyblue5      = '\033[38;5;38m'
    deepskyblue6      = '\033[38;5;39m'
    dodgerblue        = '\033[38;5;26m'
    dodgerblue1       = '\033[38;5;27m'
    dodgerblue2       = '\033[38;5;33m'
    fuchsia           = '\033[38;5;13m'
    gold              = '\033[38;5;142m'
    gold1             = '\033[38;5;178m'
    gold2             = '\033[38;5;220m'
    green             = '\033[38;5;2m'
    green1            = '\033[38;5;28m'
    green2            = '\033[38;5;34m'
    green3            = '\033[38;5;40m'
    green4            = '\033[38;5;46m'
    greenyellow       = '\033[38;5;154m'
    grey              = '\033[38;5;8m'
    grey0             = '\033[38;5;16m'
    grey3             = '\033[38;5;232m'
    grey7             = '\033[38;5;233m'
    grey11            = '\033[38;5;234m'
    grey15            = '\033[38;5;235m'
    grey19            = '\033[38;5;236m'
    grey23            = '\033[38;5;237m'
    grey27            = '\033[38;5;238m'
    grey30            = '\033[38;5;239m'
    grey35            = '\033[38;5;240m'
    grey37            = '\033[38;5;59m'
    grey39            = '\033[38;5;241m'
    grey42            = '\033[38;5;242m'
    grey46            = '\033[38;5;243m'
    grey50            = '\033[38;5;244m'
    grey53            = '\033[38;5;102m'
    grey54            = '\033[38;5;245m'
    grey58            = '\033[38;5;246m'
    grey62            = '\033[38;5;247m'
    grey63            = '\033[38;5;139m'
    grey66            = '\033[38;5;248m'
    grey69            = '\033[38;5;145m'
    grey70            = '\033[38;5;249m'
    grey74            = '\033[38;5;250m'
    grey78            = '\033[38;5;251m'
    grey82            = '\033[38;5;252m'
    grey84            = '\033[38;5;188m'
    grey85            = '\033[38;5;253m'
    grey89            = '\033[38;5;254m'
    grey93            = '\033[38;5;255m'
    grey100           = '\033[38;5;231m'
    honeydew          = '\033[38;5;194m'
    hotpink           = '\033[38;5;132m'
    hotpink1          = '\033[38;5;168m'
    hotpink2          = '\033[38;5;169m'
    hotpink3          = '\033[38;5;205m'
    hotpink4          = '\033[38;5;206m'
    indianred         = '\033[38;5;131m'
    indianred1        = '\033[38;5;167m'
    indianred2        = '\033[38;5;203m'
    indianred3        = '\033[38;5;204m'
    khaki             = '\033[38;5;185m'
    khaki1            = '\033[38;5;228m'
    lightcoral        = '\033[38;5;210m'
    lightcyan         = '\033[38;5;152m'
    lightcyan1        = '\033[38;5;195m'
    lightgoldenrod    = '\033[38;5;179m'
    lightgoldenrod1   = '\033[38;5;186m'
    lightgoldenrod2   = '\033[38;5;221m'
    lightgoldenrod3   = '\033[38;5;222m'
    lightgoldenrod4   = '\033[38;5;227m'
    lightgreen        = '\033[38;5;119m'
    lightgreen1       = '\033[38;5;120m'
    lightpink         = '\033[38;5;95m'
    lightpink1        = '\033[38;5;174m'
    lightpink2        = '\033[38;5;217m'
    lightsalmon       = '\033[38;5;137m'
    lightsalmon1      = '\033[38;5;173m'
    lightsalmon2      = '\033[38;5;216m'
    lightseagreen     = '\033[38;5;37m'
    lightskyblue      = '\033[38;5;109m'
    lightskyblue1     = '\033[38;5;110m'
    lightskyblue2     = '\033[38;5;153m'
    lightslateblue    = '\033[38;5;105m'
    lightslategrey    = '\033[38;5;103m'
    lightsteelblue    = '\033[38;5;146m'
    lightsteelblue1   = '\033[38;5;147m'
    lightsteelblue2   = '\033[38;5;189m'
    lightyellow3      = '\033[38;5;187m'
    lime              = '\033[38;5;10m'
    magenta           = '\033[38;5;127m'
    magenta1          = '\033[38;5;163m'
    magenta2          = '\033[38;5;164m'
    magenta3          = '\033[38;5;165m'
    magenta4          = '\033[38;5;200m'
    magenta5          = '\033[38;5;201m'
    maroon            = '\033[38;5;1m'
    mediumorchid      = '\033[38;5;133m'
    mediumorchid1     = '\033[38;5;134m'
    mediumorchid2     = '\033[38;5;171m'
    mediumorchid3     = '\033[38;5;207m'
    mediumpurple      = '\033[38;5;104m'
    mediumpurple      = '\033[38;5;60m'
    mediumpurple1     = '\033[38;5;97m'
    mediumpurple2     = '\033[38;5;98m'
    mediumpurple3     = '\033[38;5;135m'
    mediumpurple4     = '\033[38;5;140m'
    mediumpurple5     = '\033[38;5;141m'
    mediumspringgreen = '\033[38;5;49m'
    mediumturquoise   = '\033[38;5;80m'
    mediumvioletred   = '\033[38;5;126m'
    mistyrose         = '\033[38;5;181m'
    mistyrose         = '\033[38;5;224m'
    navajowhite       = '\033[38;5;144m'
    navajowhite1      = '\033[38;5;223m'
    navy              = '\033[38;5;4m'
    navyblue          = '\033[38;5;17m'
    olive             = '\033[38;5;3m'
    orange            = '\033[38;5;58m'
    orange1           = '\033[38;5;94m'
    orange2           = '\033[38;5;214m'
    orange3           = '\033[38;5;172m'
    orangered         = '\033[38;5;202m'
    orchid            = '\033[38;5;170m'
    orchid1           = '\033[38;5;212m'
    orchid2           = '\033[38;5;213m'
    palegreen         = '\033[38;5;77m'
    palegreen1        = '\033[38;5;114m'
    palegreen2        = '\033[38;5;121m'
    palegreen3        = '\033[38;5;156m'
    paleturquoise     = '\033[38;5;66m'
    paleturquoise1    = '\033[38;5;159m'
    palevioletred     = '\033[38;5;211m'
    pink              = '\033[38;5;175m'
    pink1             = '\033[38;5;218m'
    plum              = '\033[38;5;96m'
    plum1             = '\033[38;5;176m'
    plum2             = '\033[38;5;183m'
    plum3             = '\033[38;5;219m'
    purple            = '\033[38;5;5m'
    purple1           = '\033[38;5;54m'
    purple2           = '\033[38;5;55m'
    purple3           = '\033[38;5;56m'
    purple4           = '\033[38;5;93m'
    purple5           = '\033[38;5;129m'
    red               = '\033[38;5;9m'
    red1              = '\033[38;5;124m'
    red2              = '\033[38;5;160m'
    red3              = '\033[38;5;196m'
    rosybrown         = '\033[38;5;138m'
    royalblue         = '\033[38;5;63m'
    salmon            = '\033[38;5;209m'
    sandybrown        = '\033[38;5;215m'
    seagreen          = '\033[38;5;78m'
    seagreen1         = '\033[38;5;83m'
    seagreen2         = '\033[38;5;84m'
    seagreen3         = '\033[38;5;85m'
    silver            = '\033[38;5;7m'
    skyblue           = '\033[38;5;74m'
    skyblue1          = '\033[38;5;111m'
    skyblue2          = '\033[38;5;117m'
    slateblue         = '\033[38;5;61m'
    slateblue1        = '\033[38;5;62m'
    slateblue2        = '\033[38;5;99m'
    springgreen       = '\033[38;5;29m'
    springgreen1      = '\033[38;5;35m'
    springgreen2      = '\033[38;5;41m'
    springgreen3      = '\033[38;5;42m'
    springgreen4      = '\033[38;5;47m'
    springgreen5      = '\033[38;5;48m'
    steelblue         = '\033[38;5;67m'
    steelblue1        = '\033[38;5;68m'
    steelblue2        = '\033[38;5;75m'
    steelblue3        = '\033[38;5;81m'
    tan               = '\033[38;5;180m'
    teal              = '\033[38;5;6m'
    thistle           = '\033[38;5;182m'
    thistle1          = '\033[38;5;225m'
    turquoise         = '\033[38;5;30m'
    turquoise1        = '\033[38;5;45m'
    violet            = '\033[38;5;177m'
    wheat             = '\033[38;5;101m'
    wheat1            = '\033[38;5;229m'
    white             = '\033[38;5;15m'
    yellow            = '\033[38;5;11m'
    yellow1           = '\033[38;5;100m'
    yellow2           = '\033[38;5;106m'
    yellow3           = '\033[38;5;148m'
    yellow4           = '\033[38;5;184m'
    yellow5           = '\033[38;5;190m'
    yellow6           = '\033[38;5;226m'

# CSS standard colors using 24-bit colors
class css(basic):
    aliceblue            = '\033[38;2;240;248;255m'
    antiquewhite         = '\033[38;2;250;235;215m'
    aqua                 = '\033[38;2;0;255;255m'
    aquamarine           = '\033[38;2;127;255;212m'
    azure                = '\033[38;2;240;255;255m'
    beige                = '\033[38;2;245;245;220m'
    bisque               = '\033[38;2;255;228;196m'
    black                = '\033[38;2;0;0;0m'
    blanchedalmond       = '\033[38;2;255;235;205m'
    blue                 = '\033[38;2;0;0;255m'
    blueviolet           = '\033[38;2;138;43;226m'
    brown                = '\033[38;2;165;42;42m'
    burlywood            = '\033[38;2;222;184;135m'
    cadetblue            = '\033[38;2;95;158;160m'
    chartreuse           = '\033[38;2;127;255;0m'
    chocolate            = '\033[38;2;210;105;30m'
    coral                = '\033[38;2;255;127;80m'
    cornflowerblue       = '\033[38;2;100;149;237m'
    cornsilk             = '\033[38;2;255;248;220m'
    crimson              = '\033[38;2;220;20;60m'
    darkblue             = '\033[38;2;0;0;139m'
    darkcyan             = '\033[38;2;0;139;139m'
    darkgoldenrod        = '\033[38;2;184;134;11m'
    darkgray             = '\033[38;2;169;169;169m'
    darkgreen            = '\033[38;2;0;100;0m'
    darkgrey             = '\033[38;2;169;169;169m'
    darkkhaki            = '\033[38;2;189;183;107m'
    darkmagenta          = '\033[38;2;139;0;139m'
    darkolivegreen       = '\033[38;2;85;107;47m'
    darkorange           = '\033[38;2;255;140;0m'
    darkorchid           = '\033[38;2;153;50;204m'
    darkred              = '\033[38;2;139;0;0m'
    darksalmon           = '\033[38;2;233;150;122m'
    darkseagreen         = '\033[38;2;143;188;143m'
    darkslateblue        = '\033[38;2;72;61;139m'
    darkslategray        = '\033[38;2;47;79;79m'
    darkslategrey        = '\033[38;2;47;79;79m'
    darkturquoise        = '\033[38;2;0;206;209m'
    darkviolet           = '\033[38;2;148;0;211m'
    deeppink             = '\033[38;2;255;20;147m'
    deepskyblue          = '\033[38;2;0;191;255m'
    dimgray              = '\033[38;2;105;105;105m'
    dimgrey              = '\033[38;2;105;105;105m'
    dodgerblue           = '\033[38;2;30;144;255m'
    firebrick            = '\033[38;2;178;34;34m'
    floralwhite          = '\033[38;2;255;250;240m'
    forestgreen          = '\033[38;2;34;139;34m'
    fuchsia              = '\033[38;2;255;0;255m'
    gainsboro            = '\033[38;2;220;220;220m'
    ghostwhite           = '\033[38;2;248;248;255m'
    gold                 = '\033[38;2;255;215;0m'
    goldenrod            = '\033[38;2;218;165;32m'
    gray                 = '\033[38;2;128;128;128m'
    green                = '\033[38;2;0;128;0m'
    greenyellow          = '\033[38;2;173;255;47m'
    grey                 = '\033[38;2;128;128;128m'
    honeydew             = '\033[38;2;240;255;240m'
    hotpink              = '\033[38;2;255;105;180m'
    indianred            = '\033[38;2;205;92;92m'
    indigo               = '\033[38;2;75;0;130m'
    ivory                = '\033[38;2;255;255;240m'
    khaki                = '\033[38;2;240;230;140m'
    lavender             = '\033[38;2;230;230;250m'
    lavenderblush        = '\033[38;2;255;240;245m'
    lawngreen            = '\033[38;2;124;252;0m'
    lemonchiffon         = '\033[38;2;255;250;205m'
    lightblue            = '\033[38;2;173;216;230m'
    lightcoral           = '\033[38;2;240;128;128m'
    lightcyan            = '\033[38;2;224;255;255m'
    lightgoldenrodyellow = '\033[38;2;250;250;210m'
    lightgray            = '\033[38;2;211;211;211m'
    lightgreen           = '\033[38;2;144;238;144m'
    lightgrey            = '\033[38;2;211;211;211m'
    lightpink            = '\033[38;2;255;182;193m'
    lightsalmon          = '\033[38;2;255;160;122m'
    lightseagreen        = '\033[38;2;32;178;170m'
    lightskyblue         = '\033[38;2;135;206;250m'
    lightslategray       = '\033[38;2;119;136;153m'
    lightslategrey       = '\033[38;2;119;136;153m'
    lightsteelblue       = '\033[38;2;176;196;222m'
    lightyellow          = '\033[38;2;255;255;224m'
    lime                 = '\033[38;2;0;255;0m'
    limegreen            = '\033[38;2;50;205;50m'
    linen                = '\033[38;2;250;240;230m'
    maroon               = '\033[38;2;128;0;0m'
    mediumaquamarine     = '\033[38;2;102;205;170m'
    mediumblue           = '\033[38;2;0;0;205m'
    mediumorchid         = '\033[38;2;186;85;211m'
    mediumpurple         = '\033[38;2;147;112;219m'
    mediumseagreen       = '\033[38;2;60;179;113m'
    mediumslateblue      = '\033[38;2;123;104;238m'
    mediumspringgreen    = '\033[38;2;0;250;154m'
    mediumturquoise      = '\033[38;2;72;209;204m'
    mediumvioletred      = '\033[38;2;199;21;133m'
    midnightblue         = '\033[38;2;25;25;112m'
    mintcream            = '\033[38;2;245;255;250m'
    mistyrose            = '\033[38;2;255;228;225m'
    moccasin             = '\033[38;2;255;228;181m'
    navajowhite          = '\033[38;2;255;222;173m'
    navy                 = '\033[38;2;0;0;128m'
    oldlace              = '\033[38;2;253;245;230m'
    olive                = '\033[38;2;128;128;0m'
    olivedrab            = '\033[38;2;107;142;35m'
    orange               = '\033[38;2;255;165;0m'
    orangered            = '\033[38;2;255;69;0m'
    orchid               = '\033[38;2;218;112;214m'
    palegoldenrod        = '\033[38;2;238;232;170m'
    palegreen            = '\033[38;2;152;251;152m'
    paleturquoise        = '\033[38;2;175;238;238m'
    palevioletred        = '\033[38;2;219;112;147m'
    papayawhip           = '\033[38;2;255;239;213m'
    peachpuff            = '\033[38;2;255;218;185m'
    peru                 = '\033[38;2;205;133;63m'
    pink                 = '\033[38;2;255;192;203m'
    plum                 = '\033[38;2;221;160;221m'
    powderblue           = '\033[38;2;176;224;230m'
    purple               = '\033[38;2;128;0;128m'
    rebeccapurple        = '\033[38;2;102;51;153m'
    red                  = '\033[38;2;255;0;0m'
    rosybrown            = '\033[38;2;188;143;143m'
    royalblue            = '\033[38;2;65;105;225m'
    saddlebrown          = '\033[38;2;139;69;19m'
    salmon               = '\033[38;2;250;128;114m'
    sandybrown           = '\033[38;2;244;164;96m'
    seagreen             = '\033[38;2;46;139;87m'
    seashell             = '\033[38;2;255;245;238m'
    sienna               = '\033[38;2;160;82;45m'
    silver               = '\033[38;2;192;192;192m'
    skyblue              = '\033[38;2;135;206;235m'
    slateblue            = '\033[38;2;106;90;205m'
    slategray            = '\033[38;2;112;128;144m'
    slategrey            = '\033[38;2;112;128;144m'
    snow                 = '\033[38;2;255;250;250m'
    springgreen          = '\033[38;2;0;255;127m'
    steelblue            = '\033[38;2;70;130;180m'
    tan                  = '\033[38;2;210;180;140m'
    teal                 = '\033[38;2;0;128;128m'
    thistle              = '\033[38;2;216;191;216m'
    tomato               = '\033[38;2;255;99;71m'
    turquoise            = '\033[38;2;64;224;208m'
    violet               = '\033[38;2;238;130;238m'
    wheat                = '\033[38;2;245;222;179m'
    white                = '\033[38;2;255;255;255m'
    whitesmoke           = '\033[38;2;245;245;245m'
    yellow               = '\033[38;2;255;255;0m'
    yellowgreen          = '\033[38;2;154;205;50m'
